#!/usr/bin/perl

# perltool Copyright Toby Jaffey
# Wed Dec  1 23:47:22 GMT 1999
# Distributed under the GNU GPL
# 
# Thanks to Simon Huggins for delinting my Perl

use GD;

($filename,$xsize,$ysize) = @ARGV;

$im = new GD::Image(256,256);
$white = $im->colorAllocate(255,255,255); # background colour

while (<STDIN>)
	{
	@ops = split(/,/);
	$numArgs = int @ops;

	if ($numArgs == 1 && int @ops[0] == 0)
		{
		print STDERR "Invalid command\n";
		}
	else
		{
		if (int @ops[0] == 0 && $numArgs == 6 )
			{
			&plot(@ops[1],@ops[2],@ops[3],@ops[4],@ops[5]);
			}
		if (int @ops[0] == 1 && $numArgs == 8 )
			{
			&line(@ops[1],@ops[2],@ops[3],@ops[4],@ops[5],@ops[6],@ops[7]);
			}
		if (int @ops[0] == 2 && $numArgs == 8 )
			{
			&rect(@ops[1],@ops[2],@ops[3],@ops[4],@ops[5],@ops[6],@ops[7]);
			}
		if (int @ops[0] == 3 && $numArgs == 8 )
			{
			&fillrect(@ops[1],@ops[2],@ops[3],@ops[4],@ops[5],@ops[6],@ops[7]);
			}
		if (int @ops[0] == 4 && $numArgs == 7 )
			{
			&circle(@ops[1],@ops[2],@ops[3],@ops[4],@ops[5],@ops[6]);
			}
		if (int @ops[0] == 5 && $numArgs == 7 )
			{
			&fillcircle(@ops[1],@ops[2],@ops[3],@ops[4],@ops[5],@ops[6]);
			}
		if (int @ops[0] == 6 && $numArgs == 8 )
			{
			&ellipse(@ops[1],@ops[2],@ops[3],@ops[4],@ops[5],@ops[6],@ops[7]);
			}
		if (int @ops[0] == 7 && $numArgs == 8 )
			{
			&fillellipse(@ops[1],@ops[2],@ops[3],@ops[4],@ops[5],@ops[6],@ops[7]);
			}
		
		
		}
	}

# write our gif onto STDOUT

binmode STDOUT;
print $im->gif;

# end program


# plotting functions
# GD likes unsigned chars for rgb, it'll wrap our unsigned ints nicely.
# hmm.. maybe not, but, fuck it...

sub plot
{
$im->setPixel($_[0],$_[1],$im->colorAllocate($_[2],$_[3],$_[4]));
}

sub line
{
$im->line($_[0],$_[1],$_[2],$_[3],$im->colorAllocate($_[4],$_[5],$_[6]));
}

sub rect
{
$im->rectangle($_[0],$_[1],$_[2],$_[3],$im->colorAllocate($_[4],$_[5],$_[6]));
}

sub fillrect
{
$im->filledRectangle($_[0],$_[1],$_[2],$_[3],$im->colorAllocate($_[4],$_[5],$_[6]));
}

sub circle
{
$im->arc($_[0],$_[1],$_[2]*2,$_[2]*2,0,360,$im->colorAllocate($_[4],$_[5],$_[6]));
}

sub fillcircle
{
&circle($_[0],$_[1],$_[2],$_[3],$_[4],$_[5]);
$im->fill($_[0],$_[1],$im->colorAllocate($_[3],$_[4],$_[5]));
}

sub ellipse
{
$im->arc(($_[0]+$_[2])/2,($_[1]+$_[3])/2,$_[0]-$_[2],$_[1]-$_[3],0,360,$im->colorAllocate($_[4],$_[5],$_[6]));
}

sub fillellipse
{
&ellipse($_[0],$_[1],$_[2],$_[3],$_[4],$_[5],$_[6]);
$im->fill(($_[0]+$_[2])/2,($_[1]+$_[3])/2,$im->colorAllocate($_[4],$_[5],$_[6]));
}
