#!/usr/bin/perl

# PSDrawtool Copyright Toby Jaffey
# Wed Dec  1 23:47:22 GMT 1999
# Distributed under the GNU GPL
# 
# Thanks to Simon Huggins for delinting my Perl

$|=1;

print "%!PS-Adobe-2.0\n";
print "1.0 setlinewidth\n";
#print "0.5 0.5 scale\n";

$initDone = 0;

while (<>)
	{
	chomp;
	@a = split(/\,/);
	$type = @a[0];
	if ($type == "0")
		{
		&setcolour(@a[3..5]);
		&point(@a[1..2]);
		}	
	elsif ($type == "1")
		{
		&setcolour(@a[5..7]);
		&line(@a[1..4]);
		}	
	elsif ($type == "2")
		{
		&setcolour(@a[5..7]);
		&rect(0,@a[1..4]);
		}
	elsif ($type == "3")
		{
		&setcolour(@a[5..7]);
		&rect(1,@a[1..4]);
		}
	elsif ($type == "4")
		{
		&setcolour(@a[4..6]);
		&circle(0,@a[1..3]);
		}
	elsif ($type == "5")
		{
		&setcolour(@a[4..6]);
		&circle(1,@a[1..3]);
		}
	elsif ($type == "6")
		{
		&setcolour(@a[5..7]);
		&ellipse(0,@a[1..4]);
		}
	elsif ($type == "7")
		{
		&setcolour(@a[5..7]);
		&ellipse(1,@a[1..4]);
		}
	else
		{
		print STDERR "Invalid first code\n";
		}
	}

print "showpage\n";

sub line
{
print "newpath\n";
print @_[0] . " " . @_[1] . " moveto\n";
print @_[2] . " " . @_[3] . " lineto\n";
print "closepath stroke\n";
}

sub circle
{
print "newpath\n";
print @_[1] . " " . @_[2] . " " . @_[3] . " 0 360 arc\n";
if (@_[0] == 1)
	{
	print "fill\n";
	}
print "closepath stroke\n";
}

sub point
{
print "newpath\n";
print @_[0] . " " . @_[1] . " 0.5 0 360 arc\n";
print "closepath stroke\n";
}

sub rect
{
print "newpath\n";
print @_[1] . " " . @_[2] . " moveto\n";
print @_[1] . " " . @_[4] . " lineto\n";
print @_[3] . " " . @_[4] . " lineto\n";
print @_[3] . " " . @_[2] . " lineto\n";
if (@_[0] == 1)
	{
	print "fill\n";
	}
print "closepath stroke\n";
}

sub ellipse
{
if ($initDone==0)
	{
	&initEllipse();
	}
print "newpath\n";
$xpos = ( (@_[1]+@_[3]) / 2.0 );
$ypos = ( (@_[2]+@_[4]) / 2.0 );
print $xpos . " " . $ypos . " " . (abs ($xpos - @_[1])) . " " . (abs (@_[4] - $ypos)) . " 0 360 ellipse\n";
if (@_[0])
	{
	print "fill\n";
	}
print "closepath stroke\n";
}

sub setcolour
{
$r = (sprintf "%.3f",@_[0]/65536);
$g = (sprintf "%.3f",@_[1]/65536);
$b = (sprintf "%.3f",@_[2]/65536);

print "$r $g $b setrgbcolor\n";
}

sub initEllipse
{
$initDone = 1;
print<<EOF
/ellipsedict 8 dict def
ellipsedict /mtrx matrix put
/ellipse
  {
   /endangle exch def
    /startangle exch def
    /yrad exch def
    /xrad exch def
    /y exch def
    /x exch def
    startangle endangle gt {
      save
      /tmpangle startangle def
      /startangle endangle def
      /endangle tmpangle def
      restore
    } if
    ellipsedict begin
      /savematrix mtrx currentmatrix def
      x y translate
      xrad yrad scale
      0 0 1 startangle endangle arc
      savematrix setmatrix
    end
  } bind def
EOF
}
